<template>
  <div
    :class="{ 'scrollableOverlay-wrapper': scrollable }"
    v-scroll-lock="scrollable"
    class="contractPart-filters">
    <div
      body-scroll-lock-ignore
      class="filterGroup scrollableOverlay-container">
      <div class="filterGroup-header">
        <div class="heading _h2">
          Фильтры
        </div>
        <button
          @click="$emit('hide')"
          class="filterGroup-close">
          <img
            svg-inline
            src="~/assets/svg/redesign/cross.svg">
        </button>
      </div>

      <!--поле для Названия детали + селект Производитель-->
      <div class="filterGroup-item">
        <div class="filterGroup-field">
          <DoInputPartName
            :value="model.text"
            @input="change($event, 'text')"
            :classes="['_partName', 'multiselectThemeSmall']"
            placeholder="Название запчасти"/>
            <!-- <AppSelect
              :placeholder="'Название запчасти (в разработке)'"
              :classes="['_partName', 'no-checkbox', 'multiselectThemeSmall']"/> -->
        </div>
        <!--<div class="filterGroup-field">
          <AppSelect
            :placeholder="'Производитель'"
            :classes="['_manufacturer', 'no-checkbox', 'multiselectThemeSmall']"/>
        </div>-->
      </div>

      <!--селекты для авто: Марка-Модель-Кузов-Двигатель-Год выпуска-->
      <div class="filterGroup-item">
        <div class="filterGroup-field">
          <div class="selectGroup">
            <AppSelect
              :value="model.carManufacturer"
              :options="values.carManufacturer"
              id="carManufacturer"
              track-by="id"
              placeholder="Марка"
              :classes="['_car-mark', 'no-checkbox', 'multiselectThemeSmall']"
              :disabled="!values.carManufacturer.length"
              @select="change"
              @clear="clear('carManufacturer')">
              <template
                slot="option"
                slot-scope="{ option: { name, total } }">
                <div class="option__desc">
                  <span class="option__title">{{ name }}</span>
                  <span class="option__small">{{ total | spacifyNumber }}</span>
                </div>
              </template>
            </AppSelect>

            <AppSelect
              :value="model.carModel"
              :options="values.carModel"
              id="carModel"
              track-by="id"
              placeholder="Модель"
              :classes="['_car-model', 'no-checkbox', 'multiselectThemeSmall']"
              :disabled="!(model.carManufacturer && values.carModel.length)"
              @select="change"
              @clear="clear('carModel')">
              <template
                slot="option"
                slot-scope="{ option: { name, total } }">
                <div class="option__desc">
                  <span class="option__title">{{ name }}</span>
                  <span class="option__small">{{ total | spacifyNumber }}</span>
                </div>
              </template>
            </AppSelect>

            <AppSelect
              :value="model.chassisList"
              :options="values.chassisList"
              id="chassisList"
              track-by="id"
              placeholder="Кузов"
              :classes="['_car-body', 'no-checkbox', 'multiselectThemeSmall']"
              :disabled="!(model.carManufacturer && model.carModel && values.chassisList.length)"
              @select="change"
              @clear="clear('chassisList')">
              <template
                slot="option"
                slot-scope="{ option: { name, total } }">
                <div class="option__desc">
                  <span class="option__title">{{ name }}</span>
                  <span class="option__small">{{ total | spacifyNumber }}</span>
                </div>
              </template>
            </AppSelect>

            <AppSelect
              :value="model.enginesList"
              :options="values.enginesList"
              id="enginesList"
              track-by="id"
              placeholder="Двигатель"
              :classes="['_car-engine', 'no-checkbox', 'multiselectThemeSmall']"
              :disabled="!(model.carManufacturer && model.carModel && values.enginesList.length)"
              @select="change"
              @clear="clear('enginesList')">
              <template
                slot="option"
                slot-scope="{ option: { name, total } }">
                <div class="option__desc">
                  <span class="option__title">{{ name }}</span>
                  <span class="option__small">{{ total | spacifyNumber }}</span>
                </div>
              </template>
            </AppSelect>

            <AppSelect
              v-model="yearsList"
              id="yearsList"
              label="id"
              track-by="id"
              placeholder="Год выпуска"
              :options="values.yearsList"
              :is-multiple="true"
              :classes="['_car-year', 'multiselectThemeSmall']"
              :disabled="!(model.carManufacturer && model.carModel && values.yearsList.length)"
              @open="onYearOpened"
              @close="onYearClosed"
              @clear="clear('yearsList')">
              <template
                slot="option"
                slot-scope="{ option: { id, total } }">
                <div class="option__desc">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/checked.svg">
                  <span class="option__title">{{ id }}</span>
                  <span class="option__small">{{ total | spacifyNumber }}</span>
                </div>
              </template>
            </AppSelect>
          </div>
        </div>
      </div>

      <!--радио-кнопки для Расположения-->
      <div class="filterGroup-block">
        <div class="filterGroup-item">
          <div class="filterGroup-field">
            <label class="filterGroup-label">Место установки</label>
            <AppInputRadio
              class="_filter"
              name="placementX"
              :list="placementsX"
              :value="placement[ref.PlacementGroups.x]"
              @input="onChangePlacement($event, ref.PlacementGroups.x)"/>
          </div>
          <div class="filterGroup-field">
            <AppInputRadio
              class="_filter"
              name="placementY"
              :list="placementsY"
              :value="placement[ref.PlacementGroups.y]"
              @input="onChangePlacement($event, ref.PlacementGroups.y)"/>
          </div>
          <div class="filterGroup-field">
            <AppInputRadio
              class="_filter"
              name="placementZ"
              :list="placementsZ"
              :value="placement[ref.PlacementGroups.z]"
              @input="onChangePlacement($event, ref.PlacementGroups.z)"/>
          </div>
        </div>
      </div>

      <!--чекбокс Комплект-->
      <!-- <div class="filterGroup-item _end-block">
        <div class="filterGroup-field">
          <AppCheckbox>
            <template #label>Комплект</template>
          </AppCheckbox>
        </div>
      </div> -->

      <!--радио-кнопки для Состояния запчасти-->
      <div class="filterGroup-item">
        <div class="filterGroup-field">
          <label class="filterGroup-label">Состояние</label>
          <AppInputRadio
            class="_filter"
            name="condition"
            :list="conditions"
            :value="model.condition"
            @input="change($event, 'condition')"/>
        </div>
      </div>

      <!--чекбокс Только с фото-->
      <div class="filterGroup-item _end-block">
        <div class="filterGroup-field">
          <AppCheckbox
            :checked="model.imagesPresence === ref.ImagesPresence.IMAGES_PRESENT"
            @change="onChangeImagesPresence">
            <template #label>Только с фото</template>
          </AppCheckbox>
        </div>
      </div>

      <!--инпуты для Цены-->
      <div class="filterGroup-item">
        <div class="filterGroup-field">
          <label class="filterGroup-label">Цена, ₽</label>
          <div class="inputGroup">
            <div class="input">
              <input
                class="input-field"
                type="text"
                placeholder="От"
                :value="model.priceMin"
                @keypress="isPrice"
                @change="change($event.target.value, 'priceMin')">
            </div>
            <div class="input">
              <input
                class="input-field"
                type="text"
                placeholder="До"
                :value="model.priceMax"
                @keypress="isPrice"
                @change="change($event.target.value, 'priceMax')">
            </div>
          </div>
        </div>

        <!-- <div class="filterGroup-field">
          <AppSelect
            :id="'filterDelivery'"
            :options="values.filterDelivery"
            :track-by="'id'"
            :placeholder="'Срок доставки'"
            :classes="['_delivery', 'no-checkbox', 'multiselectThemeSmall']"
            @select="change"
            @clear="clear('filterDelivery')"/>
        </div>

        <div class="filterGroup-field">
          <AppCheckbox>
            <template #label>В наличии</template>
          </AppCheckbox>
        </div>-->
      </div>

      <!--селект по имени Продавца + селект по Рейтингу-->
      <div class="filterGroup-item">
        <!--<div
          class="filterGroup-field"
          v-if="true">
          <AppSelect
            :options="values.filterRating"
            :id="'filterRating'"
            :track-by="'id'"
            :placeholder="'Рейтинг продавца'"
            :classes="['_rating', 'no-checkbox', 'multiselectThemeSmall']"
            @select="change"
            @clear="clear('filterRating')"/>
        </div>-->
        <div class="filterGroup-field">
          <AppSelect
            :value="model.shop"
            :options="values.shop"
            id="shop"
            label="shopName"
            track-by="id"
            placeholder="Продавец"
            :classes="['_seller', 'no-checkbox', 'multiselectThemeSmall']"
            :disabled="!(model.city && model.merchantType != ref.MerchantType.MERCHANT_PERSON && values.shop.length)"
            @select="change"
            @clear="clear('shop')">
            <template
              slot="option"
              slot-scope="{ option: { shopName, total } }">
              <div class="option__desc">
                <span class="option__title">{{ shopName }}</span>
                <span class="option__small">{{ total | spacifyNumber }}</span>
              </div>
            </template>
          </AppSelect>
        </div>
      </div>

      <!--селекты для адреса: Город-Район-Метро-->
      <div class="filterGroup-item _end-block">
        <div class="filterGroup-field">
          <div class="selectGroup">
            <AppSelect
              v-if="hasCitySelect"
              :value="model.city"
              :options="values.city"
              id="city"
              track-by="id"
              placeholder="Город"
              :classes="['_address-city', 'no-checkbox', 'multiselectThemeSmall']"
              :disabled="!values.city.length"
              @select="change"
              @clear="clear('city')">
              <template
                slot="option"
                slot-scope="{ option: { name, total } }">
                <div class="option__desc">
                  <span class="option__title">{{ name }}</span>
                  <span class="option__small">{{ total | spacifyNumber }}</span>
                </div>
              </template>
            </AppSelect>
            <!-- <AppSelect
              placeholder="Район"
              :classes="['_address', 'multiselectThemeSmall']"/> -->
            <AppSelect
              :value="model.metro"
              :options="values.metro"
              id="metro"
              track-by="id"
              placeholder="Метро"
              :classes="['_address','no-checkbox', 'multiselectThemeSmall']"
              :disabled="!(model.city && values.metro && values.metro.length)"
              @select="change"
              @clear="clear('metro')">
              <template
                slot="option"
                slot-scope="{ option: { name, total } }">
                <div class="option__desc">
                  <span class="option__title">{{ name }}</span>
                  <span class="option__small">{{ total | spacifyNumber }}</span>
                </div>
              </template>
            </AppSelect>
          </div>
        </div>
        <!-- <div class="filterGroup-field">
          <AppCheckbox
            :disabled="!values.filterLocation"
            :checked="$options.checkboxState.CHECKED === values.filterOpenedNow"
            @change="change($event, 'filterOpenedNow')">
            <template #label>Открыто сейчас</template>
          </AppCheckbox>
        </div>-->
      </div>

      <!--радио-кнопки для типа объявления + чекбокс Оптовые скидки-->
      <div class="filterGroup-item _end-block">
        <div class="filterGroup-field">
          <AppInputRadio
            class="_filter"
            name="merchantType"
            :list="merchantTypes"
            :value="model.merchantType"
            @input="change($event, 'merchantType')"/>
        </div>
        <!--<div class="filterGroup-field">
          <AppCheckbox>
            <template #label>Оптовые скидки</template>
          </AppCheckbox>
        </div>-->
      </div>

      <button
        @click="$emit('reset')"
        class="button buttonAsLink _light">
        Сбросить фильтры
      </button>

      <div class="filterGroup-footer">
        <AppButton @click.native="$emit('hide')">
          <template #button-item>
            Показать предложения
          </template>
        </AppButton>
      </div>
    </div>
  </div>
</template>

<script>
import {
  reduce,
  union,
  difference,
  intersection,
} from 'lodash-es';
import {
  PartCondition,
  MerchantType,
  ImagesPresence,
  Placement,
} from '~/assets/js/enums/contract-parts-grpc';

import AppCheckbox from '~/components/redesign/app-input/app-checkbox';
import AppSelect from '~/components/redesign/app-select/app-select';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputRadio from '~/components/redesign/app-input/app-input-radio';
import DoInputPartName from '~/components/redesign/app-input/do-input-part-name';

import DisplayStates from '~/assets/js/enums/do-display-states';
import CheckboxState from '~/assets/js/enums/checkbox-state';

const PlacementGroups = Object.freeze({
  x: 1,
  y: 2,
  z: 3,
});

export default {
  name: 'ContractFilters',
  components: {
    AppButton,
    AppSelect,
    AppCheckbox,
    AppInputRadio,
    DoInputPartName,
  },
  model: {
    prop: 'model',
    event: 'change',
  },
  props: {
    display: {
      type: String,
      default: DisplayStates.LIST,
    },
    values: {
      type: Object,
      required: true,
    },
    model: {
      type: Object,
      default() { return {}; },
    },
    hasCitySelect: {
      type: Boolean,
      default: true,
    },
    scrollable: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      ref: {
        ImagesPresence,
        Placement,
        PlacementGroups,
        DisplayStates,
        MerchantType,
      },
      merchantTypes: [
        { value: MerchantType.MERCHANT_ANY, label: 'все' },
        { value: MerchantType.MERCHANT_SHOP, label: 'от компаний' },
        { value: MerchantType.MERCHANT_PERSON, label: 'от частных лиц' },
      ],
      conditions: [
        { value: PartCondition.CONDITION_ANY, label: 'любое' },
        { value: PartCondition.CONDITION_NEW, label: 'новая' },
        { value: PartCondition.CONDITION_USED, label: 'б/у' },
      ],
      placementsX: [
        { value: Placement.PLACEMENT_ANY, label: 'любое' },
        { value: Placement.PLACEMENT_FRONT, label: 'спереди' },
        { value: Placement.PLACEMENT_REAR, label: 'сзади' },
      ],
      placementsY: [
        { value: Placement.PLACEMENT_ANY, label: 'любое' },
        { value: Placement.PLACEMENT_LEFT, label: 'слева' },
        { value: Placement.PLACEMENT_RIGHT, label: 'справа' },
      ],
      placementsZ: [
        { value: Placement.PLACEMENT_ANY, label: 'любое' },
        { value: Placement.PLACEMENT_TOP, label: 'сверху' },
        { value: Placement.PLACEMENT_BOTTOM, label: 'снизу' },
      ],
      yearsList: [...this.model.yearsList],
      yearsListBeforeOpen: [...this.model.yearsList],
    };
  },
  computed: {
    placement() {
      return {
        [PlacementGroups.x]: this.model.placementList.find(
          placement => placement === Placement.PLACEMENT_FRONT || placement === Placement.PLACEMENT_REAR
        ) || Placement.PLACEMENT_ANY,
        [PlacementGroups.y]: this.model.placementList.find(
          placement => placement === Placement.PLACEMENT_LEFT || placement === Placement.PLACEMENT_RIGHT
        ) || Placement.PLACEMENT_ANY,
        [PlacementGroups.z]: this.model.placementList.find(
          placement => placement === Placement.PLACEMENT_TOP || placement === Placement.PLACEMENT_BOTTOM
        ) || Placement.PLACEMENT_ANY,
      };
    },
  },
  watch: {
    'value.yearsList'(newValue, oldValue) {
      const diff = difference(
        union(newValue, oldValue),
        intersection(newValue, oldValue),
      );
      if (diff.length) {
        this.yearsList = [...newValue];
      }
    },
  },
  created() {
    this.$options.checkboxState = CheckboxState;
  },
  methods: {
    change(value = null, filter) {
      let emitting = { ...this.model, [filter]: value };
      if (value === null) {
        switch (filter) {
          case 'carManufacturer':
            emitting = {
              ...emitting,
              carModel: null,
              chassisList: null,
              enginesList: null,
              yearsList: [],
            };
            break;
          case 'carModel':
            emitting = {
              ...emitting,
              chassisList: null,
              enginesList: null,
              yearsList: [],
            };
            break;
          case 'city':
            emitting = {
              ...emitting,
              metro: null,
            };
            break;
          case 'merchantType':
            if (Number(value) === MerchantType.MERCHANT_PERSON) {
              emitting = {
                ...emitting,
                shop: null,
              };
            }
            break;
          default:
        }
      }

      if (filter === 'priceMin'
        && this.model.priceMax
        && value > this.model.priceMax) {
        return;
      }

      if (filter === 'priceMax'
        && this.model.priceMin
        && value < this.model.priceMin) {
        return;
      }

      this.$emit('change', emitting);
    },
    clear(filterName) {
      switch (filterName) {
        case 'yearsList':
          this.change([], filterName);
          break;
        default:
          this.change(null, filterName);
      }
    },
    onYearOpened() {
      this.yearsListBeforeOpen = [...this.model.yearsList];
    },
    onYearClosed() {
      const diff = difference(
        union(this.yearsList, this.yearsListBeforeOpen),
        intersection(this.yearsList, this.yearsListBeforeOpen)
      );

      if (diff.length) {
        this.$emit('change', { ...this.model, yearsList: this.yearsList });
      }
    },
    isPrice(event) {
      // TODO: Need refactoring
      event = event || window.event;
      const charCode = event.which || event.keyCode;
      if (charCode > 31 && (charCode < 48 || charCode > 57)) {
        event.preventDefault();
        return false;
      }
      return true;
    },
    onChangeImagesPresence() {
      const newValue = this.model.imagesPresence === ImagesPresence.IMAGES_PRESENT
        ? ImagesPresence.IMAGES_ANY
        : ImagesPresence.IMAGES_PRESENT;
      this.$emit('change', { ...this.model, imagesPresence: newValue });
    },
    onChangePlacement(value, type) {
      this.$emit('change', {
        ...this.model,
        placementList: reduce(this.placement, (result, item, key) => {
          if (Number(key) !== Number(type)) {
            result.push(item);
          } else {
            result.push(value);
          }
          return result;
        }, []).filter(Boolean),
      });
    },
  },
};
</script>

<style lang="postcss">
.contractPart-filters {
  .filterGroup {
    display: flex;
    flex-wrap: wrap;
    padding: 0.5rem 1rem;

    &-header,
    &-footer {
      display: none;
    }

    &-close {
      position: absolute;
      top: 0;
      right: 0;
      display: flex;
      align-items: center;
      justify-content: center;
      width: 2.625rem;
      height: 2.625rem;
      background: none;
      border: none;
      outline: none;
      box-shadow: none;
      cursor: pointer;

      .svg {
        width: 0.625rem;
        height: 0.625rem;
        fill: var(--fill-light);
      }
    }

    &-block {
      margin-right: .5rem;
    }

    &-item {
      display: flex;
      padding: 0.5rem 0;
    }

    &-field {
      display: flex;
      align-items: center;
      margin: 0 0.5rem;
    }

    &-label {
      display: block;
      padding-right: 0.5rem;
      font-size: 0.75rem;
      font-weight: var(--font-weight-medium);
    }

    .inputGroup {
      width: 10rem;
    }

    .inputGroup {
      .input-field {
        height: 1.75rem;
        min-height: 1.75rem;
        font-size: 0.75rem;
      }
    }

    .inputCheck {
      margin-right: 1.75rem;
    }

    .inputCheck-label {
      font-size: 0.75rem;
      color: var(--color-main);
    }

    .inputCheck-box {
      margin-top: 0;
    }

    @media screen and (min-width: 981px) {
      .multiselect {
        &._delivery {
          width: 8.25rem;
          min-width: 8.25rem;
          max-width: 8.25rem;
        }
        &._rating {
          width: 9.25rem;
          min-width: 9.25rem;
          max-width: 9.25rem;
        }
        &._seller {
          width: 9.375rem;
          min-width: 9.375rem;
          max-width: 9.375rem;
        }
        &._car-mark {
          width: 10.5rem;
          min-width: 10.5rem;
          max-width: 10.5rem;
        }
        &._car-body,
        &._car-engine {
          width: 8rem;
          min-width: 8rem;
          max-width: 8rem;
          .multiselect__content-wrapper {
            width: 100%;
          }
        }
        &._car-year,
        &._car-model {
          width: 8rem;
          min-width: 8rem;
          max-width: 8rem;
        }
        &._address-city {
          width: 10.875rem;
          min-width: 10.875rem;
          max-width: 10.875rem;
        }
        &._address {
          width: 13.375rem;
          min-width: 13.375rem;
          max-width: 13.375rem;
        }
        &._manufacturer {
          width: 11rem;
          min-width: 11rem;
          max-width: 11rem;
        }
        &._partName {
          width: 32.5rem;
          min-width: 32.5rem;
          max-width: 32.5rem;

          .multiselect__select {
            display: none;
          }
        }
      }

      .buttonAsLink {
        margin-left: auto;
        padding: 0.5rem 0 0.5rem 2rem;
        font-size: 0.75rem;
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {

      .inputGroup .input-field {
        height: var(--btn-height-regular);
        max-height: var(--btn-height-regular);
      }

      .multiselect {
        height: var(--btn-height-regular);
        &._partName {
          width: 31.125rem;
          min-width: 31.125rem;
          max-width: 31.125rem;
        }
      }
    }

    @media screen and (max-width: 980px) {
      position: fixed;
      z-index: var(--z-index-over-modal);
      top: 0;
      bottom: 0;
      left: 0;
      padding: 0 1.25rem;
      flex-direction: column;
      flex-wrap: nowrap;
      justify-content: flex-start;
      width: 100vw;
      height: 100%;
      overflow-y: auto;
      overflow-x: hidden;
      border-radius: 0;
      box-shadow: none;

      &-header {
        z-index: calc(var(--z-index-over-modal) - 1);
        display: flex;
        justify-content: center;
        align-items: center;
        flex-shrink: 0;
        margin: 0 -1.25rem;
        width: 100vw;
        height: 4.375rem;
        background-color: var(--bg-main);
        border-bottom: 1px solid var(--border-color-main);
      }

      &-close {
        width: 3.75rem;
        height: 3.75rem;
        .svg {
          width: 1.25rem;
          height: 1.25rem;
        }
      }

      &-footer {
        display: flex;
        justify-content: center;
        align-items: flex-start;
        flex-shrink: 1;
        margin: -1px -1.25rem 0 -1.25rem;
        padding: 1rem 1.25rem calc(2rem + var(--mobile-browser-bar));
        width: 100vw;
        height: 100%;
        min-height: 7rem;
        background-color: var(--bg-main);
        border-top: 1px solid var(--border-color-main);

        .button {
          width: 100%;
          font-size: 1rem;
        }
      }

      &-item {
        flex-direction: column;
        flex-shrink: 0;
        padding: 0;
        width: 100%;
        &._end-block {
          padding-bottom: 1.25rem;
          border-bottom: 1px solid var(--border-color-main);
        }
      }

      &-field {
        flex-direction: column;
        align-items: flex-start;
        margin: 0;
        padding-top: 1.25rem;
        width: 100%;
      }

      &-field + &-field {
        margin-left: 0;
      }

      &-label {
        padding-bottom: 1.25rem;
        font-size: 1rem;
      }

      .inputGroup,
      .selectGroup,
      .multiselect {
        width: 100%;
      }

      .inputGroup .input-field,
      .inputCheck-label,
      .multiselect {
        font-size: 1rem;
      }

      .multiselect._partName {
        .multiselect__select {
          display: none;
        }
      }

      .inputGroup .input-field {
        height: var(--btn-height-huge);
      }

      .selectGroup {
        flex-direction: column;
        .multiselect + .multiselect {
          margin-top: 1.25rem;
        }
        .multiselect__tags {
          border-radius: 0.25rem;
        }
      }

      .buttonAsLink {
        padding: 1.25rem 0;
        font-size: 0.875rem;
        justify-content: flex-start;
      }
    }
  }
}
</style>
